#include once "SimpleGadget.bas"
#include once "StringGadget.bas"
#include once "ScrollBar.bas"
#include once "ListBox.bas"
#include once "Label.bas"
#include once "MessageBox.bas"

namespace sGUI

'InitGFX m u s s aufgerufen worden sein
declare function FileRequester(PosX as integer,PosY as integer,BtnText as string,Path as string, File as string="",FExistMode as integer=0) as string
declare sub FindContent(gad as Gadget ptr,t as string)

function FileRequester(PosX as integer,PosY as integer,BtnText as string,Path as string, File as string="",FExistMode as integer=0) as string
  function=""

  'Sichern des vom Requester bedeckten Hintergrundes
  dim as FB.Image ptr gfxbackup
  gfxbackup=imagecreate(400,300)
  get (PosX,PosY)-(PosX+399,PosY+299),gfxbackup
  
  FillA(PosX,PosY,400,300,GadgetColor,0)
  FrameB(PosX+2,PosY+21,396,277,1)
  ClearBox(PosX+3,PosY+22,394,275)
  draw string (PosX+5, PosY+3),BtnText & "...",TextColor
  
  dim as string sep,drive,originpath=curdir
  'Windows Variante
  #ifdef __fb_win32__
    sep="\"
  #endif
  'Tux Variante
  #ifdef __FB_LINUX__
    sep="/"
  #endif

  dim as integer rows
  if fontheight=8  then rows=22
  if fontheight=14 then rows=12
  if fontheight=16 then rows=11

  dim as string entry,GoToFolder,full
  GoToFolder=""
  entry=""
  chdir Path
  Path=curdir
  drive=left(Path,1)


  dim as EventHandle ptr event=new EventHandle

  dim as Gadget ptr labelp,labelf,doit,cancel,strpath,strfile,contlist,cdparent

  labelp  =AddLabel(event,PosX+5, PosY+28,phrase_path & ":",TextColor)
  strpath =AddStringGadget(event,PosX+52,PosY+25,38,Path,,,1)
  contlist=AddListBox(event,PosX+5,PosY+54,46,rows)
  labelf  =AddLabel(event,PosX+5, PosY+245,phrase_file & ":",TextColor)
  strfile =AddStringGadget(event,PosX+62,PosY+242,29,File,,,1)
  doit    =AddSimpleGadget(event,PosX+309,PosY+242,85,23,BtnText)
  cancel  =AddSimpleGadget(event,PosX+309,PosY+271,85,23,phrase_cancel)
  cdparent=AddSimpleGadget(event,PosX+370,PosY+25,24,23,"..")

  TO_ClearText(contlist)
  FindContent(contlist,"D")
  FindContent(contlist,"F")
  UpdateGadget(contlist)

  GadgetOn(labelp,cdparent)
  do
    event->xSleep(1,0)
    if event->GADGETMESSAGE then
      select case event->GADGETMESSAGE

        'Pfadeingabe
        case strpath
          chdir UExport(GetString(strpath))           'Wechsel ins Directory
          Path=UImport(curdir)                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige

        case contlist
          entry=TO_GetLineContent(contlist,GetListBoxVal(contlist))

          if entry<>"" then
            if left(entry,6)="<DIR> " then                'wenn entry ein Directory
              GoToFolder=right(entry,len(entry)-6)
              chdir UExport(GoToFolder)                   'Wechsel ins Directory
              Path=UImport(curdir)                        'Setze aktuellen Pfad

              TO_ClearText(contlist)
              FindContent(contlist,"D")
              FindContent(contlist,"F")
              UpdateGadget(contlist)

              SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige
            else                                          'ansonsten ist entry ein Dateiname
              File=entry
              SetString(strfile,File)
            end if
          end if

        case cdparent
          chdir ".."                                  'Wechsel ins bergeordnete Directory
          Path=UImport(curdir)                        'Setze aktuellen Pfad
          
          TO_ClearText(contlist)
          FindContent(contlist,"D")
          FindContent(contlist,"F")
          UpdateGadget(contlist)

          SetString(strpath,Path)                     'Aktualisiere die Pfadanzeige        

				'Beenden und Rckabe eines Strings
        case strfile,doit
          File=GetString(strfile)
          if File<>"" then
            if right(Path,1)<> sep then
              full=UExport(Path) & sep & UExport(File)
            else
              full=UExport(Path) & UExport(File)
            end if
            if FExistMode then
              if fileexists(full) then
                function=full
                event->EXITEVENT=1
              else
                GadgetSleep(labelp,cdparent)
                MessageBox(PosX+20,PosY+100,phrase_fileaccessdenied,phrase_error,MBType_OK)
                RestoreActivation(labelp,cdparent)
              end if
            else
              function=full
              event->EXITEVENT=1
            end if
          end if

        'Abbruch des FileRequesters
        case cancel
          event->EXITEVENT=1
          function=""

      end select
    end if
  loop until event->EXITEVENT
  delete event
  chdir originpath
  put (PosX,PosY),gfxbackup,pset
  imagedestroy gfxbackup
end function


sub FindContent(gad as Gadget ptr,t as string)
  dim as integer attr
  dim as string entryname,pre
  if ucase(t)="D" then 'bei "D" suche nach Verzeichnissen
    attr=&H10 + &H01
    pre="<DIR> "       '"Vorsilbe" um Verzeichnisse von Dateien unterscheiden zu knnen
  end if
  if ucase(t)="F" then  'bei "F" suche nach Dateien
    attr=&H00
    pre=""
  end if

  entryname=dir("*",attr)
  do
    if (len(entryname)>0) and (entryname<>".") and (entryname<>"..") then TO_AppendLine(gad,pre & UImport(entryname))
    entryname=dir
  loop while len(entryname)
end sub

end namespace
